using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public struct audio_output
	{
		public IntPtr name;
		public IntPtr description;
		public IntPtr next;
	}

	public class AudioOutput : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_audio_output_list_get(IntPtr instance);
		[DllImport("vlc")]
		static extern void libvlc_audio_output_list_release(IntPtr output);

		audio_output ao;

		~AudioOutput(){libvlc_audio_output_list_release (Handle);}
		public AudioOutput(IntPtr raw) : base(raw)
		{
			ao = (audio_output)Marshal.PtrToStructure (Handle,typeof(audio_output));
		}
		public AudioOutput(Instance instance)
			: this(libvlc_audio_output_list_get (instance.Handle))
		{}
		public string Name{get{return Marshal.PtrToStringAuto (ao.name);}}
		public string Description{get{return Marshal.PtrToStringAuto (ao.description);}}
		public AudioOutput Next{get{return new AudioOutput(ao.next);}}
	}
}

