using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public struct audio_output_device
	{
		public IntPtr next;
		public IntPtr device;
		public IntPtr description;
	}

	public class AudioOutputDevice : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_audio_output_device_list_get(IntPtr instance,
                                     [MarshalAs(UnmanagedType.LPStr)] string ao_name);
		[DllImport("vlc")]
		static extern void libvlc_audio_output_device_list_release(IntPtr device);

		audio_output_device aod;

		~AudioOutputDevice(){libvlc_audio_output_device_list_release (Handle);}
		public AudioOutputDevice(IntPtr raw) : base(raw)
		{
			aod = (audio_output_device)Marshal.PtrToStructure (Handle,typeof(audio_output_device));
		}

		public AudioOutputDevice Next{
			get{return new AudioOutputDevice(aod.next);}
		}
		public string Device{
			get{return Marshal.PtrToStringAuto (aod.device);}
		}
		public string Description{
			get{return Marshal.PtrToStringAuto (aod.description);}
		}
	}
}

