using System;

namespace LibVlc
{
	public enum EventType{
		/* Append new event types at the end of a category.
     * Do not remove, insert or re-order any entry.
     * Keep this in sync with lib/event.c:event_type_name(). */
		MediaMetaChanged=0,
		MediaSubItemAdded,
		MediaDurationChanged,
		MediaParsedChanged,
		MediaFreed,
		MediaStateChanged,
		
		MediaPlayerMediaChanged=0x100,
		MediaPlayerNothingSpecial,
		MediaPlayerOpening,
		MediaPlayerBuffering,
		MediaPlayerPlaying,
		MediaPlayerPaused,
		MediaPlayerStopped,
		MediaPlayerForward,
		MediaPlayerBackward,
		MediaPlayerEndReached,
		MediaPlayerEncounteredError,
		MediaPlayerTimeChanged,
		MediaPlayerPositionChanged,
		MediaPlayerSeekableChanged,
		MediaPlayerPausableChanged,
		MediaPlayerTitleChanged,
		MediaPlayerSnapshotTaken,
		MediaPlayerLengthChanged,
		MediaPlayerVout,
		
		MediaListItemAdded=0x200,
		MediaListWillAddItem,
		MediaListItemDeleted,
		MediaListWillDeleteItem,
		
		MediaListViewItemAdded=0x300,
		MediaListViewWillAddItem,
		MediaListViewItemDeleted,
		MediaListViewWillDeleteItem,
		
		MediaListPlayerPlayed=0x400,
		MediaListPlayerNextItemSet,
		MediaListPlayerStopped,
		
		MediaDiscovererStarted=0x500,
		MediaDiscovererEnded,
		
		VlmMediaAdded=0x600,
		VlmMediaRemoved,
		VlmMediaChanged,
		VlmMediaInstanceStarted,
		VlmMediaInstanceStopped,
		VlmMediaInstanceStatusInit,
		VlmMediaInstanceStatusOpening,
		VlmMediaInstanceStatusPlaying,
		VlmMediaInstanceStatusPause,
		VlmMediaInstanceStatusEnd,
		VlmMediaInstanceStatusError
	}
	public struct Event
	{
		int type;
		IntPtr sender;
	}
}

