using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class MediaDiscoverer : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_discoverer_new_from_name(
			IntPtr instance, [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern void libvlc_media_discoverer_release(IntPtr md);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_discoverer_localized_name(IntPtr md);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_discoverer_media_list(IntPtr md);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_discoverer_event_manager(IntPtr md);
		[DllImport("vlc")]
		static extern int libvlc_media_discoverer_is_running(IntPtr md);

		~MediaDiscoverer(){libvlc_media_discoverer_release (Handle);}
		public MediaDiscoverer (Instance instance, string name)
			: base(libvlc_media_discoverer_new_from_name(instance.Handle,name))
		{}
		public string LocalizedName{get{
				return Marshal.PtrToStringAuto (libvlc_media_discoverer_localized_name (Handle));
			}}
		public LibVlc.MediaList MediaList{
			get{
				return new LibVlc.MediaList(libvlc_media_discoverer_media_list (Handle));
			}
		}
		public LibVlc.EventManager EventManager{
			get{return new LibVlc.EventManager(libvlc_media_discoverer_event_manager (Handle));}
		}
		public bool IsRunning(){
			return (libvlc_media_discoverer_is_running(Handle)==1)?true:false;
		}
	}
}

