using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class MediaList : Object
	{
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_new(IntPtr instance);
		[DllImport("vlc")]
		static extern void libvlc_media_list_set_media(IntPtr list, IntPtr media);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_media(IntPtr list);
		[DllImport("vlc")]
		static extern int libvlc_media_list_add_media(IntPtr list, IntPtr media);
		[DllImport("vlc")]
		static extern int libvlc_media_list_insert_media(IntPtr list, IntPtr media, int position); 
		[DllImport("vlc")]
		static extern int libvlc_media_list_remove_index(IntPtr list, int index);
		[DllImport("vlc")]
		static extern int libvlc_media_list_count(IntPtr list);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_item_at_index(IntPtr list, int index);
		[DllImport("vlc")]
		static extern int libvlc_media_list_index_of_item(IntPtr list, IntPtr media);
		[DllImport("vlc")]
		static extern int libvlc_media_list_is_readonly(IntPtr list);
		[DllImport("vlc")]
		static extern void libvlc_media_list_lock(IntPtr list);
		[DllImport("vlc")]
		static extern void libvlc_media_list_unlock(IntPtr list);
		[DllImport("vlc")]
		static extern IntPtr libvlc_media_list_event_manager(IntPtr list);

		public MediaList (IntPtr raw) : base(raw)
		{}
		public MediaList (Instance instance) 
			: base(libvlc_media_list_new (instance.Handle))
		{}
		public LibVlc.Media Media{
			get{
				return new LibVlc.Media(libvlc_media_list_media (Handle));
			}set{
				libvlc_media_list_set_media (Handle,value.Handle);
			}
		}
		public bool AddMedia(LibVlc.Media media){
			return (libvlc_media_list_add_media (Handle,media.Handle)==0)?true:false;
		}
		public bool InsertMedia(LibVlc.Media media, int position){
			return (libvlc_media_list_insert_media (Handle,media.Handle,position)==0)?true:false;
		}
		public bool RemoveIndex(int index){
			return (libvlc_media_list_remove_index (Handle,index)==0)?true:false;
		}
		public int Count{get{return libvlc_media_list_count (Handle);}}
		public LibVlc.Media ItemAtIndex(int index){
			return new LibVlc.Media(libvlc_media_list_item_at_index (Handle,index));
		}
		public LibVlc.Media this[int index]{
			get{
				return ItemAtIndex (index);
			}
		}
		public int IndexOf(LibVlc.Media media){
			return libvlc_media_list_index_of_item (Handle,media.Handle);
		}
		public bool IsReadonly(){
			return (libvlc_media_list_is_readonly(Handle)==1)?true:false;
		}
		public void Lock(){libvlc_media_list_lock (Handle);}
		public void Unlock(){libvlc_media_list_unlock (Handle);}
		public LibVlc.EventManager EventManager{
			get{
				return new LibVlc.EventManager(libvlc_media_list_event_manager (Handle));
			}
		}
	}
}

