using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public struct module_description
	{
		public IntPtr name;
		public IntPtr shortname;
		public IntPtr longname;
		public IntPtr help;
		public IntPtr next;
	}

	public class ModuleDescription : Object
	{
		[DllImport("vlc")]
		static extern void libvlc_module_description_list_release(IntPtr desc);

		module_description md;

		public ModuleDescription (IntPtr raw) : base(raw)
		{
			md = (module_description)Marshal.PtrToStructure (raw, typeof(module_description));
		}
		public void Release(){libvlc_module_description_list_release (Handle);}

		public string Name{get{return Marshal.PtrToStringAuto (md.name);}}
		public string ShortName{get{return Marshal.PtrToStringAuto (md.shortname);}}
		public string LongName{get{return Marshal.PtrToStringAuto (md.longname);}}
		public string Help{get{return Marshal.PtrToStringAuto (md.help);}}
		public ModuleDescription Next {
			get{
				if(md.next == IntPtr.Zero)return null;
				return new ModuleDescription(md.next);
			}
		}
	}
}

