using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public struct track_description
	{
		public int id;
		public IntPtr name;
		public IntPtr next;
	}

	public class TrackDescription : Object
	{
		[DllImport("vlc")]
		static extern void libvlc_track_description_list_release(IntPtr desc);

		track_description td;

		~TrackDescription(){libvlc_track_description_list_release (Handle);}
		public TrackDescription(IntPtr raw) : base(raw)
		{
			td = (track_description)Marshal.PtrToStructure (Handle,typeof(track_description));
		}

		public int Id{get{return td.id;}}
		public string Name{get{return Marshal.PtrToStringAuto (td.name);}}
		public TrackDescription Next{get{return new TrackDescription(td.next);}}
	}
}

