using System;
using System.Runtime.InteropServices;

namespace LibVlc
{
	public class Vlm : Object
	{
		[DllImport("vlc")]
		static extern void libvlc_vlm_release(IntPtr instance);
		[DllImport("vlc")]
		static extern int libvlc_vlm_add_broadcast(IntPtr instance,
                            [MarshalAs(UnmanagedType.LPStr)] string name,
                            [MarshalAs(UnmanagedType.LPStr)] string input,
                            [MarshalAs(UnmanagedType.LPStr)] string output,
		                                            int option,
                            [MarshalAs(UnmanagedType.LPStr)] string options,
		                                            int enabled,
		                                            int loop);
		
		[DllImport("vlc")]
		static extern int libvlc_vlm_change_media(IntPtr instance,
                            [MarshalAs(UnmanagedType.LPStr)] string name,
                            [MarshalAs(UnmanagedType.LPStr)] string input,
                            [MarshalAs(UnmanagedType.LPStr)] string output,
		                                            int option,
                            [MarshalAs(UnmanagedType.LPStr)] string options,
		                                            int enabled,
		                                            int loop);
		[DllImport("vlc")]
		static extern int libvlc_vlm_add_vod(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    [MarshalAs(UnmanagedType.LPStr)] string input,
		                                     int option,
		                    [MarshalAs(UnmanagedType.LPStr)] string options,
		                                     int enabled,
		                    [MarshalAs(UnmanagedType.LPStr)] string mux);
		[DllImport("vlc")]
		static extern int libvlc_vlm_del_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern int libvlc_vlm_play_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern int libvlc_vlm_pause_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern int libvlc_vlm_stop_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern IntPtr libvlc_vlm_show_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name);
		[DllImport("vlc")]
		static extern int libvlc_vlm_seek_media(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                        float percentage);
		[DllImport("vlc")]
		static extern int libvlc_vlm_set_enabled(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                         int enabled);
		[DllImport("vlc")]
		static extern int libvlc_vlm_set_output(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    [MarshalAs(UnmanagedType.LPStr)] string output);
		[DllImport("vlc")]
		static extern int libvlc_vlm_set_input(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    [MarshalAs(UnmanagedType.LPStr)] string input);
		[DllImport("vlc")]
		static extern int libvlc_vlm_set_mux(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    [MarshalAs(UnmanagedType.LPStr)] string mux);
		[DllImport("vlc")]
		static extern int libvlc_vlm_set_loop(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    int loop);
		[DllImport("vlc")]
		static extern int libvlc_vlm_add_input(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                    [MarshalAs(UnmanagedType.LPStr)] string input);
		[DllImport("vlc")]
		static extern float libvlc_vlm_get_media_instance_position(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                                           int num_instance);
		[DllImport("vlc")]
		static extern int libvlc_vlm_get_media_instance_time(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                                           int num_instance);
		[DllImport("vlc")]
		static extern int libvlc_vlm_get_media_instance_length(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                                           int num_instance);
		[DllImport("vlc")]
		static extern int libvlc_vlm_get_media_instance_rate(IntPtr instance,
		                    [MarshalAs(UnmanagedType.LPStr)] string name,
		                                                           int num_instance);
		[DllImport("vlc")]
		static extern IntPtr libvlc_vlm_get_event_manager(IntPtr instance);

		~Vlm(){libvlc_vlm_release (Handle);}
		public Vlm (Instance instance) : base(instance.Handle)
		{}
		public bool AddBroadcast(string name, string input, string output, int option,
		                         string options, bool enabled, int loop){
			return (libvlc_vlm_add_broadcast (Handle,name,input,output,option,
			                                 options,(enabled)?1:0,loop)==0)?true:false;
		}
		public bool ChangeMedia(string name, string input, string output, int option,
		                         string options, bool enabled, int loop){
			return (libvlc_vlm_change_media (Handle,name,input,output,option,
			                                 options,(enabled)?1:0,loop)==0)?true:false;
		}
		public bool AddVod(string name, string input, int option, string options,
		                  bool enabled, string mux){
			return (libvlc_vlm_add_vod (Handle,name,input,option,options,(enabled)?1:0,mux)
			       ==0)?true:false;
		}
		public bool DelMedia(string name){
			return (libvlc_vlm_del_media(Handle,name)==0)?true:false;
		}
		public bool SetEnabled(string name, bool enabled){
			return (libvlc_vlm_set_enabled (Handle,name,(enabled)?1:0)==0)?true:false;
		}
		public bool SetInput(string name, string input){
			return (libvlc_vlm_set_input (Handle,name,input)==0)?true:false;
		}
		public bool SetOutput(string name, string output){
			return (libvlc_vlm_set_output (Handle,name,output)==0)?true:false;
		}
		public bool AddInput(string name, string input){
			return (libvlc_vlm_add_input (Handle,name,input)==0)?true:false;
		}
		public bool SetMux(string name, string muxer){
			return (libvlc_vlm_set_mux (Handle,name,muxer)==0)?true:false;
		}
		public bool SetLoop(string name,int loop){
			return (libvlc_vlm_set_loop (Handle,name,loop)==0)?true:false;
		}
		public bool PlayMedia(string name){
			return (libvlc_vlm_play_media (Handle,name)==0)?true:false;
		}
		public bool PauseMedia(string name){
			return (libvlc_vlm_pause_media (Handle,name)==0)?true:false;
		}
		public bool StopMedia(string name){
			return (libvlc_vlm_stop_media (Handle,name)==0)?true:false;
		}
		public string ShowMedia(string name){
			return Marshal.PtrToStringAuto (libvlc_vlm_show_media (Handle,name));
		}
		public bool SeekMedia(string name,float percentage){
			return (libvlc_vlm_seek_media (Handle,name,percentage)==0)?true:false;
		}
		public float GetMediaInstancePosition(string name, int instance){
			return libvlc_vlm_get_media_instance_position (Handle,name,instance);
		}
		public int GetMediaInstanceTime(string name, int instance){
			return libvlc_vlm_get_media_instance_time (Handle,name,instance);
		}
		public int GetMediaInstanceLength(string name, int instance){
			return libvlc_vlm_get_media_instance_length (Handle,name,instance);
		}
		public int GetMediaInstanceRate(string name, int instance){
			return libvlc_vlm_get_media_instance_rate (Handle,name,instance);
		}
		public LibVlc.EventManager EventManager{
			get{
				return new LibVlc.EventManager(libvlc_vlm_get_event_manager (Handle));
			}
		}
	}
}

